{"+ pure data objects"
    {base
        {loadbang init closebang bang trigger int float symbol list send receive inlet outlet pd pd~ clone key keyname pdcontrol print}}
    {list
        {pack unpack "list append" "list prepend" "list store" "list split" "list trim" "list length" "list fromsymbol" "list tosymbol"}}
    {array
        {"array define" "array size" "array get" "array set" "array sum" "array quantile" "array random" "array max" "array min"}}
    {text
        {"text define" "text size" "text get" "text set" "text insert" "text delete" "text tolist" "text fromlist" "text search" "text sequence"}}
    {file
        {"file define" "file handle" "file size" "file isfile" "file isdirectory" "file stat" "file glob" "file split" "file join" "file splitext" "file splitname" "file mkdir" "file copy" "file move" "file delete" "file which"}}
    {flow
        {spigot select route change moses max min clip swap}}
    {math
        {+ - * / == abs pow expr mod div sin cos tan atan atan2 sqrt log exp wrap}}
    {logic
        {< > <= == >= && || != & | >> <<}}
    {convert
        {mtof ftom powtodb dbtopow rmstodb dbtorms}}
    {time
        {metro delay pipe line timer realtime cputime until}}
    {midi
        {notein noteout ctlin ctlout makenote stripnote pgmin pgmout bendin bendout touchin touchout midiin midiout midiclkin sysexin }}
    {tables
        {tabread tabread4 tabwrite soundfiler table array}}
    {"signal~ base"
        {dac~ adc~ sig~ send~ receive~ throw~ catch~ samplerate~ readsf~}}
    {math~
        {+~ -~ *~ /~ max~ min~ abs~ clip~ sqrt~ rsqrt~ pow~ log~ exp~ expr~ }}
    {filters~
        {lop~ hip~ bp~ vcf~ biquad~ bob~ slop~}}
    {delay~
        {delwrite~ delread~ delread4~ vd~}}
    {detect~
        {bonk~ sigmund~ fiddle~ threshold~ env~}}
    {reverb~
        {rev1~ rev2~ rev3~}}
    {"user interface"
        {bng tgl nbx hslider vslider hradio vradio cnv openpanel savepanel}}
}
{"+ ceammc objects"
  {base {
        counter function function.call gain~ matrix~ metro.pattern metro.random
        metro.seq mix~ nsig~ radio spring window xdac~ xfade2~ xfade~ loadexpr
    }}
          {"graphic user interface" {
        ui.aview ui.bang ui.button ui.colorpanel ui.display ui.dsp~ ui.env
        ui.filter ui.filter~ ui.gain2~ ui.gain~ ui.icon ui.incdec ui.keyboard
        ui.knob ui.label ui.link ui.matrix ui.menu ui.meter~ ui.midi
        ui.mouse_filter ui.mouse_route ui.number ui.number~ ui.plot~ ui.polar
        ui.preset ui.radio ui.rslider ui.scope~ ui.slider ui.slider2d
        ui.sliders ui.spectroscope~ ui.tab ui.toggle histogram
    }}
    {flow {
        flow.append flow.change flow.count flow.delay
        flow.demultiplex flow.demultiplex2~ flow.demultiplex~ flow.dollar flow.dup flow.float
        flow.gate flow.greater flow.greater_eq flow.group flow.interval
        flow.less flow.less_eq flow.list2many flow.match flow.mem
        flow.multiplex flow.multiplex2~ flow.multiplex~ flow.once flow.pack
        flow.pass flow.pass_if flow.pipe flow.queue flow.reject flow.reject_if
        flow.ring flow.route flow.select flow.space flow.speedlim flow.split
        flow.stack flow.sync flow.sync_pack flow.tee~
        flow.replace flow.map flow.debounce flow.threshold flow.fade flow.mean flow.median flow.between route.float route.random
    }}
    {list {
        list.^at list.^contains list.^search list.all_of list.any_of
        list.append list.apply_to list.at list.choice list.contains list.convolve list.correlate list.count
        list.count_if list.delta list.distribution list.do list.each
        list.enumerate list.equal list.first list.gen list.histogram
        list.insert list.integrator list.last list.length list.math list.map list.max list.mean
        list.min list.none_of list.normalize list.pass list.pass_if list.prepend
        list.product list.range list.reduce list.reject list.remove list.remove_if
        list.repack list.repeat list.resample list.resize list.reverse
        list.rldecode list.rlencode list.rotate list.route list.rundiff list.runsum list.search
        list.separate list.seq list.set list.shift list.shuffle list.slice
        list.sort list.sort_with list.split list.stretch list.sum list.unique
        list.unpack list.unzip list.walk list.zip list.fade list.pipe
    }}
    {math {
        math.abs math.abs~ math.acos math.acosh math.acosh~ math.acos~
        math.and math.approx math.asin math.asinh math.asinh~ math.asin~
        math.atan math.atanh math.atanh~ math.atan~ math.binomial math.cabs~ math.carg~
        math.cbrt math.cbrt~ math.cdiv~ math.ceil math.ceil~ math.cexp~
        math.cmul~ math.cos math.cosh math.cosh~ math.cos~ math.div math.e
        math.erf math.erf~ math.exp math.exp2 math.exp2~ math.expr math.exp~
        math.floor math.floor~ math.gamma math.gamma~ math.gcd math.inf
        math.lcm math.lgamma math.lgamma~ math.log math.log10 math.log10~
        math.log2 math.log2~ math.log~ math.mul math.nan math.neg math.or
        math.pi math.pi~ math.polyeval math.reciprocal math.reciprocal~
        math.round math.round~ math.sign math.sin math.sinh math.sinh~
        math.sin~ math.sqrt math.sqrt~ math.squared math.squared~
        math.sync_add math.sync_and math.sync_div math.sync_eq math.sync_ge
        math.sync_gt math.sync_le math.sync_lt math.sync_mod math.sync_mul
        math.sync_ne math.sync_or math.sync_sub math.sync_xor math.tan
        math.tanh math.tanh~ math.tan~ math.trunc math.trunc~ math.nan~ math.inf~ math.sync_rshift math.sync_lshift
    }}
        {random {
        random.float random.int random.list random.atom random.gauss random.discrete random.linear
        random.pw_const random.pw_lin random.step random.urn
    }}
        {"symbol / string / msg" {
        symbol.split symbol.equal symbol.length symbol.num_compare symbol2any symbol2list list2symbol string string.contains string.ends_with string.equal string.format
        string.join string.length string.match string.remove string.replace
        string.split string.starts_with string.substr string2symbol string2list string2any msg msg.after msg.onload msg.sched
    }}
    {array {
        array.bpm array.copy array.do array.each array.fill array.hist
        array.mean array.minmax array.play~ array.plot array.plot~
        array.resample array.rms array.set array.stddev array.stretch
        array.sum array.sum2 array.variance array.vplay array.window
        plot.geomspace~ plot.hist~ plot.linspace~ plot.logspace~
        plot.response~
    }}
    {"sound analysis~" {
        an.attack~ an.amplitude~ an.pitch~ an.onset an.onset~ an.pitchtrack~ an.tempo~ an.voice~ an.zero~
    }}
    {chaos {
        chaos.gbman0 chaos.gbman0~ chaos.jong chaos.logistic chaos.std0
        chaos.std0~
    }}
    {sequence {
        seq.arp seq.bangs seq.counter seq.life seq.matrix seq.nbangs
        seq.phasor seq.toggles sequencer
    }}
    {convert {
        array.p2s array.s2p conv.amp2dbfs conv.amp2dbfs~ conv.bits2bang
        conv.bits2int conv.bits2note conv.bits2pos conv.bpm2hz conv.bpm2ms
        conv.bpm2sec conv.car2pol conv.cc2amp conv.dbfs2amp conv.dbfs2amp~
        conv.degree2key conv.edge2bang conv.hex2int conv.int2bits conv.lin2curve conv.lin2exp
        conv.lin2lin conv.lin2lin~ conv.list2props conv.midi2freq conv.ms2bpm
        conv.ms2samp conv.ms2samp~ conv.phase2rad conv.phase2rad~
        conv.pitch2midi conv.pol2car conv.rad2phase conv.rad2phase~
        conv.samp2ms conv.samp2ms~ conv.samp2sec conv.sec2bpm conv.sec2samp
        conv.sec2str conv.sig2float~ conv.str2sec music.dur2time music.voice2midi curve.circular curve.sigmoid curve.exponential curve.seat curve.sinusoid
    }}

    {envelope {
        env.adsr~ env.ar~ env.asr~ env.concat env.follow~ env.mix env.smooth~
        env.tscale env.tshift env.vscale envelope env2array env2vline
        vline2env
    }}

    {"hardware midi & protocol" {
        mouse keypress keyrelease arduino tinkerkit hw.apple_smc hw.apple_sms hw.arduino hw.cpu_temp hw.display
        hw.kbd_light hw.light_sensor midi.cc midi.clock midi.kbd midi.oct midi.sustain midi.sysex midi.vrand midi.ctl2str midi.event2ctl midi.event2note midi.event2prg midi.file
        midi.key2str midi.prg2str midi.track midi.tuning midi.vramp proto.midi proto.midi.cc proto.midi.sysex proto.firmata proto.xtouch_ext proto.mpv proto.tinkerkit proto.dmx leapmotion
    }}
    {"sound player~ & sampler~" {
        snd.play~  snd.file array.play~ array.vplay array.grainer~ array.circular~ modplug~ speech.flite~ speech.flite live.capture~ samp.time~ sfizz~
    }}

    {"noise~ osc~ lfo~" {
        noise.crackle~ noise.lfreq0~ noise.lfreq~ noise.pink~ noise.white~ osc.blit~ osc.impulse~ osc.pulse~ osc.saw4~ osc.saw~ osc.sinfb~
        osc.sin~ osc.square~ osc.tri~ lfo.+pulse~ lfo.+saw~ lfo.+square~ lfo.+tri~ lfo.impulse~ lfo.mosc~ lfo.pulse~
        lfo.saw~ lfo.square~ lfo.tri~ click~
    }}

    {predicates {
        is_any is_bang is_data is_dict is_even is_file is_float is_list is_odd
        is_pointer is_symbol
    }}
    {preset {
        preset.float preset.list preset.storage preset.symbol
    }}
    {synth~ {
        synth.bee3~ synth.birds~ synth.church_bell~ synth.dubdub~ synth.dx7~
        synth.eguitar~ synth.english_bell~ synth.french_bell~ synth.german_bell~ synth.risset_bell~ synth.standard_bell~ synth.tube_bell~ synth.fgrain~ synth.glass_harm~ synth.glitch~
        synth.harpsichord~ synth.kick~ synth.snare~ synth.ks~ synth.marimba~ synth.piano~ synth.rhodey~
        synth.risset_arp~ synth.risset_tone~ synth.russian_bell~
        synth.shakers~ synth.sitar~ synth.wurley~ fluid~
    }}
    {fx~ {
        fx.bitdown~ fx.chorus~ fx.distortion1~ fx.distortion2~ fx.distortion3~
        fx.distortion~ fx.drive~ fx.drone_box~ fx.echo~ fx.echo2~ fx.flanger~
        fx.freeverb2~ fx.freeverb~ fx.freqshift~ fx.granulator~ fx.greyhole~
        fx.infrev~ fx.looper~ fx.pitchshift_s~ fx.pitchshift~ fx.recho~ fx.rb_pitchshift~ fx.room~ fx.sdelay~ fx.secho~ fx.shimmer~
        fx.tapiir~ fx.vocoder~ fx.wahwah~ fx.zita_rev1~ soundtouch~
    }}
    {filter~ {
        ui.filter~ flt.bpf12~ 
        flt.dcblock2~ flt.dcblock~ flt.eq10~ flt.eq_peak~
        flt.highshelf~ flt.lowshelf~
        flt.moog_vcf~ flt.resonbp~
    }}
    {"graphic audio~" {
        gsnd.play~ gseq.gate gseq.sliders gseq.matrix gseq.env gsynth.birds~ gsynth.church_bell~ gsynth.dubdub~
        gsynth.eguitar~ gsynth.ks~ gsynth.marimba~ gsynth.risset_arp~ gsynth.risset_tone~
        gfx.bitdown~ gfx.chorus~ gfx.distortion~ gfx.distortion1~ gfx.distortion2~ gfx.distortion3~
        gfx.drive~ gfx.drone_box~ gfx.echo~ gfx.flanger~ gfx.freeverb~ gfx.freeverb2~ gfx.granulator~ gfx.greyhole~ gfx.pitchshift~
        gfx.sdelay~ gfx.vocoder~ gfx.wahwah~ gfx.zita_rev1~ gdyn.comp~ gdyn.comp2~ gdyn.gate~ gdyn.gate2~ gflt.bpf12~ gflt.bpf24~ gflt.eq_peak_cq~
        gflt.eq_peak~ gflt.eq10~ gflt.highshelf~ gflt.hpf12~ gflt.hpf24~ gflt.lowshelf~ gflt.lpf12~ gflt.lpf24~ gflt.moog_vcf~ gflt.notch~ gflt.resonbp~
        gnoise.crackle~ gnoise.lfreq~ gnoise.lfreq0~ gspat.pan4~ gspat.pan8~
    }}
    {"sound spatialization~" {
        hoa.2d.decoder~ hoa.2d.encoder~ hoa.2d.map~ hoa.2d.optim~
        hoa.2d.projector~ hoa.2d.recomposer~ hoa.2d.rotate~ hoa.2d.wider~
        hoa.@process hoa.in hoa.in~ hoa.out hoa.out~ hoa.process~ hoa.scope~
        pan.cos~ pan.linsig~ pan.lin~ pan.spread~ pan.sqrt~ spat.pan4~
        spat.pan8~ spat.zita8~
    }}
    {"patch / system / script" {
        canvas.current canvas.dir canvas.name canvas.path canvas.top ceammc.search file.size
        patch.args path.basename path.dirname path.exists path.is_dir path.lsdir path.normalize path.search path.split system.colorpanel system.cursor system.exec system.getenv
        system.hostname system.memsize system.memused system.screen_size system.exit net.host2ip expand_env lang.faust~ ui.faust~ ofelia
    }}
    {timeline {
        tl.bang tl.cue tl.timeline tl.toggle tl.transport
    }}
}
{"+ ofelia objects" 
    {basic
        {of.window of.draw of.camera of.view of.ortho of.depth ofelia}
    }
    {"geo 2d"
        {of.rectangle of.rectrounded of.circle of.ellipse of.triangle of.plane of.path of.quad of.meshcircle of.text}
    }
    {"geo 3d"
        {of.box of.sphere of.cone of.cylinder of.icosphere of.mesh of.line of.bezier of.noiseplane}
    }
    {transform
        {of.translate of.rotate of.scale of.node of.particle of.repeat of.iterate of.gravitation of.separator of.pushmatrix of.popmatrix}
    }
    {"color & light"
        {of.color of.colorloop of.worldlight of.pointlight of.spotlight of.arealight of.light of.material of.blend}
    }
    {"image & pixel"
        {of.image of.multiimage of.movie of.video of.grabscreen of.fbo of.pixnoise of.pixgradient}
    }
    {interaction
        {of.mouse of.keyboard of.keypress of.keyrelease of.dragged}
    }
    {"audio & signal~"
        {of.oscillo~ of.soundplayer}
    }
}
{"+ gem objects" 
    {control
        {gemhead gemwin gemmouse gemkeyboard gemkeyname gemkeypress gemcam gemview}
    }
    {"manipulators"
        {accumrotate camera depth linear_path ortho polygon_smooth repeat rotate rotateXYZ scale scaleXYZ shearXY shearXZ shearYX shearYZ shearZX shearZY separator spline_path translate translateXYZ}
    }
    {"color & material"
        {alpha ambient ambientRGB color colorRGB diffuse diffuseRGB emission emissionRGB shininess specular specularRGB}
    }
    {geos
        {circle colorSquare cone cube cuboid curve curve3d cylinder disk imageVert model multimodel newWave polygon primTri rectangle ripple rubber slideSquare sphere square teapot text2d text3d textextruded textoutline triangle}
    }
    {"particles"
        {part_head part_color part_damp part_draw part_follow part_gravity part_info part_killold part_killslow part_orbitpoint part_render part_size part_source part_targetcolor part_targetsize part_velocity part_vertex}
    }
    {light
        {light world_light spot_light nolight}
    }
    {"pixel source"
        {pix_image pix_film pix_video pix_set pix_imageInPlace pix_multiimage pix_noise pix_sig2pix~ pix_snap pix_snap2tex pix_buffer pix_buffer_read pix_buffer_write pix_movie movie_player}
    }
    {"pixel fx"
        {pix_2grey pix_a_2grey pix_aging pix_alpha pix_background pix_backlight pix_biquad pix_bitmask pix_buf pix_colormatrix pix_color pix_colorreduce pix_convolve pix_crop pix_curve pix_delay pix_diff pix_dot pix_draw pix_dump pix_duotone pix_flip pix_frei0r pix_freeframe pix_gain pix_grey pix_halftone pix_hsv2rgb pix_invert pix_kaleidoscope pix_levels pix_lumaoffset pix_metaimage pix_motionblur pix_movement pix_movement2 pix_normalize pix_offset pix_posterize pix_puzzle pix_rds pix_rectangle pix_refraction pix_resize pix_rgb2hsv pix_rgba pix_roll pix_rtx pix_scanline pix_tIIR pix_threshold}
    }
    {"pixel texture"
        {pix_texture pix_coordinate gemframebuffer}
    }
    {"pixel mixing"
        {pix_mix pix_chroma_key pix_coloralpha pix_takealpha pix_composite pix_mask pix_subtract pix_multiply}
    }
    {"pixel output"
        {pix_data pix_info pix_pix2sig~ pix_blob pix_histo pix_colorclassify pix_write}
    }
}
